#include <iostream>

using namespace std;

int main()

{
    int N;      //betegek szama
    int Omv, Amv, Bmv, ABmv;        //vercsoportok-mennyiver van
    char O, A, B, AB;       //vercsoportok
    cin>>N;
    cin>>Omv>>Amv>>Bmv>>ABmv;
    char vercsopa, vercsopb, vercsopab, vercsopo;
    int vermennyia, vermennyib, vermennyiab, vermennyio;
    int i;

    cin>>vercsopo>>vermennyio;
    cin>>vercsopa>>vermennyia;
    cin>>vercsopb>>vermennyib;
    cin>>vercsopab>>vermennyiab;




            while(Amv!=0)
            {
                Amv-=vermennyia;

            }

            cout<<Omv<<"\t"<<Amv<<"\t"<<Bmv<<"\t"<<ABmv<<endl;


        while(Bmv!=0)
        {
            Bmv-=vermennyib;
        }
                cout<<Omv<<"\t"<<Amv<<"\t"<<Bmv<<"\t"<<ABmv<<endl;




        while(ABmv!=0)
        {
            ABmv-=vermennyiab;
        }

            cout<<Omv<<"\t"<<Amv<<"\t"<<Bmv<<"\t"<<ABmv<<endl;





        while(Omv!=0)
        {
            Omv=-vermennyio;
        }
        cout<<Omv<<"\t"<<Amv<<"\t"<<Bmv<<"\t"<<ABmv<<endl;



    return 0;
}